//+------------------------------------------------------------------+
//|                                         alb - moving average.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  1
#property indicator_color1   Lime

//
//
//
//
//

extern int    swingCount = 5;
extern int    price      = PRICE_CLOSE;
extern double speed      = 1.0;

//
//
//
//
//

double swingBuffer[];
double maBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,maBuffer);
   SetIndexBuffer(1,swingBuffer);
      speed = MathMax(speed,0.000001);
   return(0);
}
int deinit()
{
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      int swing = 0;
         if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swing = -1;
         if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swing =  1;
      swingBuffer[i] = swing;
   
      //
      //
      //
      //
      //
      
      int k = i;
      int n = 0;
         for (; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
               double albPeriod = MathMax(MathRound((k-i)/swingCount/speed),1);
      maBuffer[i] = iCustom(NULL,0,"TMAcentered",albPeriod,price,0,i);
   }
   return(0);
}